diff --git a/src/bin/pg_rewind/libpq_fetch.c b/src/bin/pg_rewind/libpq_fetch.c
index bf4dfc23b9..327af2f828 100644
--- a/src/bin/pg_rewind/libpq_fetch.c
+++ b/src/bin/pg_rewind/libpq_fetch.c
@@ -22,9 +22,18 @@
 #include "filemap.h"
 #include "pg_rewind.h"
 #include "port/pg_bswap.h"
+#include "storage/page_compression.h"
 
-PGconn	   *conn = NULL;
 
+typedef union PageCompressAddrBuffer
+{
+	char		data[MAX_PAGE_COMPRESS_ADDRESS_FILE_SIZE];
+	double		force_align_d;
+	int64		force_align_i64;
+} PageCompressAddrBuffer;
+
+PGconn			*conn = NULL;
+static PageCompressAddrBuffer	pca_buffer;
 /*
  * Files are fetched max CHUNKSIZE bytes at a time.
  *
@@ -35,9 +44,16 @@ PGconn	   *conn = NULL;
 #define CHUNKSIZE 1000000
 
 static void receiveFileChunks(const char *sql);
-static void execute_pagemap(datapagemap_t *pagemap, const char *path);
+static void receiveCompressedRelationAddressFileChunks(filemap_t *map, const char *sql);
+static void execute_pagemap(datapagemap_t *pagemap, const char *path,
+							bool iscompressedrel, int chunk_size,
+							int prealloc_chunks, compressedpagemap_t *first_compressedpagemap);
 static char *run_simple_query(const char *sql);
 static void run_simple_command(const char *sql);
+static void fetch_compressed_relation_range(const char *path, int chunk_size, 
+											BlockNumber blocknum, int nblocks,
+											int prealloc_chunks,
+											compressedpagemap_t *first_compressedpagemap);
 
 void
 libpqConnect(const char *connstr)
@@ -169,6 +185,7 @@ libpqGetCurrentXlogInsertLocation(void)
 void
 libpqProcessFileList(void)
 {
+	char		sqlbuf[1024];
 	PGresult   *res;
 	const char *sql;
 	int			i;
@@ -197,18 +214,22 @@ libpqProcessFileList(void)
 		"       WHERE parent.isdir = 't'\n"
 		")\n"
 		"SELECT path || filename, size, isdir,\n"
-		"       pg_tablespace_location(pg_tablespace.oid) AS link_target\n"
+		"       pg_tablespace_location(pg_tablespace.oid) AS link_target,\n"
+		"       CASE WHEN filename ~ '_pca$' THEN pg_read_binary_file(path || filename, 0, %d, true)\n"
+		"            ELSE NULL\n"
+		"       END AS pchdr\n"
 		"FROM files\n"
 		"LEFT OUTER JOIN pg_tablespace ON files.path = 'pg_tblspc/'\n"
 		"                             AND oid::text = files.filename\n";
-	res = PQexec(conn, sql);
+	snprintf(sqlbuf, sizeof(sqlbuf), sql, sizeof(PageCompressHeader));
+	res = PQexec(conn, sqlbuf);
 
 	if (PQresultStatus(res) != PGRES_TUPLES_OK)
 		pg_fatal("could not fetch file list: %s",
 				 PQresultErrorMessage(res));
 
 	/* sanity check the result set */
-	if (PQnfields(res) != 4)
+	if (PQnfields(res) != 5)
 		pg_fatal("unexpected result set while fetching file list");
 
 	/* Read result to local variables */
@@ -241,7 +262,24 @@ libpqProcessFileList(void)
 		else
 			type = FILE_TYPE_REGULAR;
 
-		process_source_file(path, type, filesize, link_target);
+		if(!PQgetisnull(res, i, 4))
+		{
+			PageCompressHeader	*pchdr;
+			size_t				length = 0;
+			char			*strvalue = PQgetvalue(res, i, 4);
+
+			pchdr = (PageCompressHeader	*)PQunescapeBytea((const unsigned char*)strvalue, &length);
+
+			if(length == sizeof(PageCompressHeader))
+				process_source_file(path, type, filesize, link_target, pchdr);
+			else
+				process_source_file(path, type, filesize, link_target, NULL);
+			
+			if(pchdr)
+				PQfreemem(pchdr);
+		}
+		else
+			process_source_file(path, type, filesize, link_target, NULL);
 	}
 	PQclear(res);
 }
@@ -257,14 +295,14 @@ libpqProcessFileList(void)
  *----
  */
 static void
-receiveFileChunks(const char *sql)
+receiveCompressedRelationAddressFileChunks(filemap_t *map, const char *sql)
 {
 	PGresult   *res;
 
 	if (PQsendQueryParams(conn, sql, 0, NULL, NULL, NULL, NULL, 1) != 1)
 		pg_fatal("could not send query: %s", PQerrorMessage(conn));
 
-	pg_log_debug("getting file chunks");
+	pg_log_debug("getting compressed relation address file chunks");
 
 	if (PQsetSingleRowMode(conn) != 1)
 		pg_fatal("could not set libpq connection to single row mode");
@@ -274,6 +312,7 @@ receiveFileChunks(const char *sql)
 		char	   *filename;
 		int			filenamelen;
 		int64		chunkoff;
+		char		chunkoff_str[32];
 		int			chunksize;
 		char	   *chunk;
 
@@ -343,23 +382,219 @@ receiveFileChunks(const char *sql)
 		{
 			pg_log_debug("received null value for chunk for file \"%s\", file has been deleted",
 						 filename);
-			remove_target_file(filename, true);
+			// TODO  remove_target_file(filename, true);
+			pg_free(filename);
+			PQclear(res);
+			continue;
+		}
+
+		/*
+		 * Separate step to keep platform-dependent format code out of
+		 * translatable strings.
+		 */
+		snprintf(chunkoff_str, sizeof(chunkoff_str), INT64_FORMAT, chunkoff);
+		pg_log_debug("received chunk for file \"%s\", offset %s, size %d",
+					 filename, chunkoff_str, chunksize);
+
+		/* fill compressed relation address in filemap */
+		filename[strlen(filename) - strlen("_pca")] = '\0';
+
+
+		memset(pca_buffer.data, 0x00, sizeof(PageCompressAddrBuffer));
+		memcpy(pca_buffer.data + chunkoff, chunk, chunksize);
+
+		fill_compressed_relation_address(NULL, filename, (PageCompressHeader *)pca_buffer.data);
+
+		pg_free(filename);
+
+		PQclear(res);
+	}
+}
+
+
+/*----
+ * Runs a query, which returns pieces of files from the remote source data
+ * directory, and overwrites the corresponding parts of target files with
+ * the received parts. The result set is expected to be of format:
+ *
+ * path		text	-- path in the data directory, e.g "base/1/123"
+ * begin	int8	-- offset within the file
+ * chunk	bytea	-- file content
+ * iscompressedchunk	bool	-- if this is a chunk for compressed relation data file
+ * blocknum	int4	-- block number of this compressed chunk
+ * chunkindex int4	-- chunk index of this compressed chunk
+ * nchunks	int4	-- number of chunks for this block
+ * prealloc_chunks	int4	-- prealloc_chunks for this relation
+ *----
+ */
+static void
+receiveFileChunks(const char *sql)
+{
+	PGresult   *res;
+
+	if (PQsendQueryParams(conn, sql, 0, NULL, NULL, NULL, NULL, 1) != 1)
+		pg_fatal("could not send query: %s", PQerrorMessage(conn));
+
+	pg_log_debug("getting file chunks");
+
+	if (PQsetSingleRowMode(conn) != 1)
+		pg_fatal("could not set libpq connection to single row mode");
+
+	while ((res = PQgetResult(conn)) != NULL)
+	{
+		char	   *filename;
+		int			filenamelen;
+		int64		chunkoff;
+		int			chunksize;
+		char	   *chunk;
+		bool		iscompressedchunk;
+
+		switch (PQresultStatus(res))
+		{
+			case PGRES_SINGLE_TUPLE:
+				break;
+
+			case PGRES_TUPLES_OK:
+				PQclear(res);
+				continue;		/* final zero-row result */
+
+			default:
+				pg_fatal("unexpected result while fetching remote files: %s",
+						 PQresultErrorMessage(res));
+		}
+
+		/* sanity check the result set */
+		if (PQnfields(res) != 8 || PQntuples(res) != 1)
+			pg_fatal("unexpected result set size while fetching remote files");
+
+		if (PQftype(res, 0) != TEXTOID ||
+			PQftype(res, 1) != INT8OID ||
+			PQftype(res, 2) != BYTEAOID ||
+			PQftype(res, 3) != BOOLOID ||
+			PQftype(res, 4) != INT4OID ||
+			PQftype(res, 5) != INT4OID ||
+			PQftype(res, 6) != INT4OID ||
+			PQftype(res, 7) != INT4OID)
+		{
+			pg_fatal("unexpected data types in result set while fetching remote files: %u %u %u",
+					 PQftype(res, 0), PQftype(res, 1), PQftype(res, 2));
+		}
+
+		if (PQfformat(res, 0) != 1 &&
+			PQfformat(res, 1) != 1 &&
+			PQfformat(res, 2) != 1 &&
+			PQfformat(res, 3) != 1 &&
+			PQfformat(res, 4) != 1 &&
+			PQfformat(res, 5) != 1 &&
+			PQfformat(res, 6) != 1 &&
+			PQfformat(res, 7) != 1)
+		{
+			pg_fatal("unexpected result format while fetching remote files");
+		}
+
+		if (PQgetisnull(res, 0, 0) ||
+			PQgetisnull(res, 0, 1) ||
+			PQgetisnull(res, 0, 3) ||
+			PQgetisnull(res, 0, 4) ||
+			PQgetisnull(res, 0, 5) ||
+			PQgetisnull(res, 0, 6) ||
+			PQgetisnull(res, 0, 7))
+		{
+			pg_fatal("unexpected null values in result while fetching remote files");
+		}
+
+		if (PQgetlength(res, 0, 1) != sizeof(int64) ||
+			PQgetlength(res, 0, 3) != sizeof(bool) ||
+			PQgetlength(res, 0, 4) != sizeof(int32) ||
+			PQgetlength(res, 0, 5) != sizeof(int32) ||
+			PQgetlength(res, 0, 6) != sizeof(int32) ||
+			PQgetlength(res, 0, 7) != sizeof(int32))
+		{
+			pg_fatal("unexpected result length while fetching remote files");
+		}
+
+		/* Read result set to local variables */
+		memcpy(&chunkoff, PQgetvalue(res, 0, 1), sizeof(int64));
+		chunkoff = pg_ntoh64(chunkoff);
+		chunksize = PQgetlength(res, 0, 2);
+
+		filenamelen = PQgetlength(res, 0, 0);
+		filename = pg_malloc(filenamelen + 1);
+		memcpy(filename, PQgetvalue(res, 0, 0), filenamelen);
+		filename[filenamelen] = '\0';
+
+		chunk = PQgetvalue(res, 0, 2);
+
+		memcpy(&iscompressedchunk, PQgetvalue(res, 0, 3), sizeof(bool));
+		iscompressedchunk = (iscompressedchunk != 0 ? true : false);
+
+		/*
+		 * If a file has been deleted on the source, remove it on the target
+		 * as well.  Note that multiple unlink() calls may happen on the same
+		 * file if multiple data chunks are associated with it, hence ignore
+		 * unconditionally anything missing.  If this file is not a relation
+		 * data file, then it has been already truncated when creating the
+		 * file chunk list at the previous execution of the filemap.
+		 * 
+		 * For compressed relation, directly deleting the target file may cause
+		 * errors in the subsequent processing of the tuples corresponding to 
+		 * the same file, so skip it simply here. This relation can be deleted
+		 * when WAL is applied later.
+		 */
+		if (PQgetisnull(res, 0, 2))
+		{
+			pg_log_debug("received null value for chunk for file \"%s\", file has been deleted",
+						 filename);
+			/* TODO compressed relation*/
+			if(!iscompressedchunk)
+				remove_target_file(filename, true);
 			pg_free(filename);
 			PQclear(res);
 			continue;
 		}
 
-		pg_log_debug("received chunk for file \"%s\", offset %lld, size %d",
-					 filename, (long long int) chunkoff, chunksize);
+		if(iscompressedchunk)
+		{
+			int		blocknum, chunkindex, nchunks, prealloc_chunks;
 
-		open_target_file(filename, false);
+			memcpy(&blocknum, PQgetvalue(res, 0, 4), sizeof(int32));
+			blocknum = pg_ntoh32(blocknum);
 
-		write_target_range(chunk, chunkoff, chunksize);
+			memcpy(&chunkindex, PQgetvalue(res, 0, 5), sizeof(int32));
+			chunkindex = pg_ntoh32(chunkindex);
+
+			memcpy(&nchunks, PQgetvalue(res, 0, 6), sizeof(int32));
+			nchunks = pg_ntoh32(nchunks);
+
+			memcpy(&prealloc_chunks, PQgetvalue(res, 0, 7), sizeof(int32));
+			prealloc_chunks = pg_ntoh32(prealloc_chunks);
+
+			pg_log_debug("received compressed chunk for file \"%s\", offset %lld, size %d,"
+						 " blocknum %d, chunkindex %d, nchunks %d, prealloc_chunks %d",
+						filename, (long long int) chunkoff, chunksize,
+						blocknum, chunkindex, nchunks, prealloc_chunks);
+
+			filename[filenamelen - 4] = '\0';
+			open_target_compressed_relation(filename);
+
+			write_target_compressed_relation_chunk(chunk, chunksize, blocknum, chunkindex, nchunks, prealloc_chunks);
+		}
+		else
+		{
+			pg_log_debug("received chunk for file \"%s\", offset %lld, size %d",
+						filename, (long long int) chunkoff, chunksize);
+
+			open_target_file(filename, false);
+
+			write_target_range(chunk, chunkoff, chunksize);
+		}
 
 		pg_free(filename);
 
 		PQclear(res);
 	}
+	close_target_file();
+
 }
 
 /*
@@ -424,7 +659,7 @@ fetch_file_range(const char *path, uint64 begin, uint64 end)
 		else
 			len = (unsigned int) (end - begin);
 
-		snprintf(linebuf, sizeof(linebuf), "%s\t" UINT64_FORMAT "\t%u\n", path, begin, len);
+		snprintf(linebuf, sizeof(linebuf), "%s\t" UINT64_FORMAT "\t%u\tfalse\t0\t0\t0\t0\n", path, begin, len);
 
 		if (PQputCopyData(conn, linebuf, strlen(linebuf)) != 1)
 			pg_fatal("could not send COPY data: %s",
@@ -434,6 +669,178 @@ fetch_file_range(const char *path, uint64 begin, uint64 end)
 	}
 }
 
+/*
+ * Write a compressed relation block range to a temporary table in the server.
+ *
+ * The range is sent to the server as a COPY formatted line, to be inserted
+ * into the 'fetchchunks' temporary table. It is used in receiveFileChunks()
+ * function to actually fetch the data.
+ */
+static void
+fetch_compressed_relation_range(const char *path, int chunk_size, BlockNumber blocknum, int nblocks,
+								int prealloc_chunks, compressedpagemap_t *first_compressedpagemap)
+{
+	char		linebuf[MAXPGPATH + 23];
+	int			i;
+	compressedpagemap_t *compressedpagemap = first_compressedpagemap;
+
+	/* read blocks */
+	for(i=0; i < nblocks; i++)
+	{
+		int			j;
+		BlockNumber	blkno = blocknum + i;
+
+		while(compressedpagemap != NULL)
+		{
+			if(compressedpagemap->blkno == blkno)
+				break;
+			compressedpagemap = compressedpagemap->next;
+		}
+
+		if(compressedpagemap == NULL)
+			pg_fatal("could not find compressedpagemap for block %d of file \"%s\"",
+					 blkno, path);
+
+		for(j=0; j < compressedpagemap->nchunks; j++)
+		{
+			uint64		begin;
+			int			length = chunk_size;
+			int			chunkindex = j;
+			pc_chunk_number_t	chunkno = compressedpagemap->chunknos[j];
+
+			begin = OffsetOfPageCompressChunk(chunk_size, chunkno);
+
+			while(j + 1 < compressedpagemap->nchunks && 
+			   compressedpagemap->chunknos[j + 1]== compressedpagemap->chunknos[j] + 1)
+			{
+				length += chunk_size;
+				j++;
+			}
+
+			snprintf(linebuf, sizeof(linebuf), "%s_pcd\t" UINT64_FORMAT "\t%u\ttrue\t%u\t%u\t%u\t%u\n",
+					 path, begin, length, blkno, chunkindex,
+					 compressedpagemap->nchunks, prealloc_chunks);
+
+			if (PQputCopyData(conn, linebuf, strlen(linebuf)) != 1)
+				pg_fatal("could not send COPY data: %s",
+						PQerrorMessage(conn));
+		}
+	}
+}
+
+/*
+ * Fetch all address of changed compressed blocks from remote source data directory.
+ */
+void
+libpq_fetchCompressedRelationAddress(filemap_t *map)
+{
+	char		linebuf[MAXPGPATH + 23];
+	const char *sql;
+	PGresult   *res;
+	int			i;
+
+	/*
+	 * First create a temporary table, and load it with the blocks that we
+	 * need to fetch.
+	 */
+	sql = "CREATE TEMPORARY TABLE fetchchunks_pca(path text, begin int8, len int4)";
+	run_simple_command(sql);
+
+	sql = "COPY fetchchunks_pca FROM STDIN";
+	res = PQexec(conn, sql);
+
+	if (PQresultStatus(res) != PGRES_COPY_IN)
+		pg_fatal("could not send file list: %s",
+				 PQresultErrorMessage(res));
+	PQclear(res);
+
+	for (i = 0; i < map->narray; i++)
+	{
+		file_entry_t *entry;
+		int			chunk_size, len;
+		datapagemap_iterator_t *iter;
+		BlockNumber blkno;
+		off_t		range_start = MAX_PAGE_COMPRESS_ADDRESS_FILE_SIZE;
+		off_t		range_end = 0;
+
+		entry = map->array[i];
+
+		if(entry->type != FILE_TYPE_COMPRESSED_REL)
+			continue;
+
+		chunk_size = entry->chunk_size;
+		/* add changed blocks in pagemap */
+		iter = datapagemap_iterate(&entry->pagemap);
+		while (datapagemap_next(iter, &blkno))
+		{
+			off_t start, end;
+
+			/* calculate postion of this block in compressed relation address file */
+
+			start = OffsetOfPageCompressAddr(chunk_size, blkno);
+			if(start < range_start)
+				range_start = start;
+
+			end = OffsetOfPageCompressAddr(chunk_size, blkno + 1);
+			if(end > range_end)
+				range_end = end;
+		}
+		pg_free(iter);
+
+		/* add blocks range in source's tail */
+		if(entry->action == FILE_ACTION_COPY_TAIL)
+		{
+			off_t start, end;
+		
+			/* calculate postion of tail range in compressed relation address file */
+
+			//TODO blkno = (BlockNumber)(entry->oldsize / BLCKSZ);
+			start = OffsetOfPageCompressAddr(chunk_size, entry->oldblocks - 1);
+			if(start < range_start)
+				range_start = start;
+
+			//blkno = (BlockNumber)(entry->newsize / BLCKSZ);
+			end = OffsetOfPageCompressAddr(chunk_size, entry->newblocks);
+			if(end > range_end)
+				range_end = end;
+		}
+
+		len = range_end - range_start;
+
+		if(len > 0)
+		{
+			snprintf(linebuf, sizeof(linebuf), "%s\t" UINT64_FORMAT "\t%u\n", entry->pca->path, range_start, len);
+
+			if (PQputCopyData(conn, linebuf, strlen(linebuf)) != 1)
+				pg_fatal("could not send COPY data: %s",
+						PQerrorMessage(conn));
+		}
+	}
+
+	if (PQputCopyEnd(conn, NULL) != 1)
+		pg_fatal("could not send end-of-COPY: %s",
+				 PQerrorMessage(conn));
+
+	while ((res = PQgetResult(conn)) != NULL)
+	{
+		if (PQresultStatus(res) != PGRES_COMMAND_OK)
+			pg_fatal("unexpected result while sending file list: %s",
+					 PQresultErrorMessage(res));
+		PQclear(res);
+	}
+
+	/*
+	 * We've now copied the list of file ranges that we need to fetch to the
+	 * temporary table. Now, actually fetch all of those ranges.
+	 */
+	sql =
+		"SELECT path, begin,\n"
+		"  pg_read_binary_file(path, begin, len, true) AS chunk\n"
+		"FROM fetchchunks_pca\n";
+
+	receiveCompressedRelationAddressFileChunks(map, sql);
+}
+
 /*
  * Fetch all changed blocks from remote source data directory.
  */
@@ -449,7 +856,9 @@ libpq_executeFileMap(filemap_t *map)
 	 * First create a temporary table, and load it with the blocks that we
 	 * need to fetch.
 	 */
-	sql = "CREATE TEMPORARY TABLE fetchchunks(path text, begin int8, len int4);";
+	sql = "CREATE TEMPORARY TABLE fetchchunks(path text, begin int8, len int4,"
+	    			" iscompressedchunk bool, blocknum int4, chunkindex int4,"
+					" nchunks int4, prealloc_chunks int4);";
 	run_simple_command(sql);
 
 	sql = "COPY fetchchunks FROM STDIN";
@@ -462,10 +871,15 @@ libpq_executeFileMap(filemap_t *map)
 
 	for (i = 0; i < map->narray; i++)
 	{
+		bool iscompressedrel = false;
 		entry = map->array[i];
 
+		if(entry->type == FILE_TYPE_COMPRESSED_REL)
+			iscompressedrel = true;
+
 		/* If this is a relation file, copy the modified blocks */
-		execute_pagemap(&entry->pagemap, entry->path);
+		execute_pagemap(&entry->pagemap, entry->path, iscompressedrel, entry->chunk_size,
+						entry->prealloc_chunks, entry->first_compressedpagemap);
 
 		switch (entry->action)
 		{
@@ -480,11 +894,20 @@ libpq_executeFileMap(filemap_t *map)
 				break;
 
 			case FILE_ACTION_TRUNCATE:
-				truncate_target_file(entry->path, entry->newsize);
+				if(iscompressedrel)
+					truncate_target_compressed_relation(entry->path, entry->newblocks);
+				else
+					truncate_target_file(entry->path, entry->newsize);
 				break;
 
 			case FILE_ACTION_COPY_TAIL:
-				fetch_file_range(entry->path, entry->oldsize, entry->newsize);
+				if(iscompressedrel)
+					fetch_compressed_relation_range(entry->path, entry->chunk_size, entry->oldblocks,
+													entry->newblocks - entry->oldblocks,
+													entry->prealloc_chunks,
+													entry->first_compressedpagemap);
+				else
+					fetch_file_range(entry->path, entry->oldsize, entry->newsize);
 				break;
 
 			case FILE_ACTION_REMOVE:
@@ -515,14 +938,16 @@ libpq_executeFileMap(filemap_t *map)
 	 */
 	sql =
 		"SELECT path, begin,\n"
-		"  pg_read_binary_file(path, begin, len, true) AS chunk\n"
+		"  pg_read_binary_file(path, begin, len, true) AS chunk,\n"
+		"  iscompressedchunk, blocknum, chunkindex, nchunks, prealloc_chunks\n"
 		"FROM fetchchunks\n";
 
 	receiveFileChunks(sql);
 }
 
 static void
-execute_pagemap(datapagemap_t *pagemap, const char *path)
+execute_pagemap(datapagemap_t *pagemap, const char *path, bool iscompressedrel, int chunk_size,
+				int prealloc_chunks, compressedpagemap_t *first_compressedpagemap)
 {
 	datapagemap_iterator_t *iter;
 	BlockNumber blkno;
@@ -531,9 +956,13 @@ execute_pagemap(datapagemap_t *pagemap, const char *path)
 	iter = datapagemap_iterate(pagemap);
 	while (datapagemap_next(iter, &blkno))
 	{
-		offset = blkno * BLCKSZ;
-
-		fetch_file_range(path, offset, offset + BLCKSZ);
+		if(iscompressedrel)
+			fetch_compressed_relation_range(path, chunk_size, blkno, 1, prealloc_chunks, first_compressedpagemap);
+		else
+		{
+			offset = blkno * BLCKSZ;
+			fetch_file_range(path, offset, offset + BLCKSZ);
+		}
 	}
 	pg_free(iter);
 }
diff --git a/src/bin/pg_rewind/pg_rewind.c b/src/bin/pg_rewind/pg_rewind.c
index 0ec52cb032..a3fd8bc566 100644
--- a/src/bin/pg_rewind/pg_rewind.c
+++ b/src/bin/pg_rewind/pg_rewind.c
@@ -380,6 +380,7 @@ main(int argc, char **argv)
 	if (showprogress)
 		pg_log_info("reading target file list");
 	traverse_datadir(datadir_target, &process_target_file);
+	process_compressed_relation();
 
 	/*
 	 * Read the target WAL from last checkpoint before the point of fork, to
@@ -392,6 +393,8 @@ main(int argc, char **argv)
 		pg_log_info("reading WAL in target");
 	extractPageMap(datadir_target, chkptrec, lastcommontliIndex,
 				   ControlFile_target.checkPoint, restore_command);
+
+	fetchCompressedRelationAddress();
 	filemap_finalize();
 
 	if (showprogress)
diff --git a/src/bin/pg_rewind/pg_rewind.h b/src/bin/pg_rewind/pg_rewind.h
index 8a9319ed67..9c6d5decae 100644
--- a/src/bin/pg_rewind/pg_rewind.h
+++ b/src/bin/pg_rewind/pg_rewind.h
@@ -32,6 +32,7 @@ extern int	targetNentries;
 
 /* general state */
 extern PGconn *conn;
+extern PGconn *pca_conn;
 
 /* Progress counters */
 extern uint64 fetch_size;
diff --git a/src/bin/pg_rewind/t/007_page_compression.pl b/src/bin/pg_rewind/t/007_page_compression.pl
new file mode 100644
index 0000000000..d5320c15f7
--- /dev/null
+++ b/src/bin/pg_rewind/t/007_page_compression.pl
@@ -0,0 +1,199 @@
+use strict;
+use warnings;
+use TestLib;
+use Test::More tests => 26;
+
+use FindBin;
+use lib $FindBin::RealBin;
+
+use RewindTest;
+
+sub run_test
+{
+	my $test_mode = shift;
+
+	RewindTest::setup_cluster($test_mode);
+	RewindTest::start_primary();
+
+	# Create a test table and insert a row in primary.
+	primary_psql("CREATE TABLE tbl1 (d text) WITH(compresstype=pglz, compress_chunk_size=1024, compress_prealloc_chunks=2)");
+	primary_psql("INSERT INTO tbl1 VALUES ('in primary')");
+
+	# This test table will be used to test truncation, i.e. the table
+	# is extended in the old primary after promotion
+	primary_psql("CREATE TABLE trunc_tbl (d text) WITH(compresstype=pglz, compress_chunk_size=1024, compress_prealloc_chunks=2)");
+	primary_psql("INSERT INTO trunc_tbl VALUES ('in primary')");
+
+	# This test table will be used to test the "copy-tail" case, i.e. the
+	# table is truncated in the old primary after promotion
+	primary_psql("CREATE TABLE tail_tbl (id integer, d text) WITH(compresstype=pglz, compress_chunk_size=1024, compress_prealloc_chunks=2)");
+	primary_psql("INSERT INTO tail_tbl VALUES (0, 'in primary')");
+
+	# This test table is dropped in the old primary after promotion.
+	primary_psql("CREATE TABLE drop_tbl (d text) WITH(compresstype=pglz, compress_chunk_size=1024, compress_prealloc_chunks=2)");
+	primary_psql("INSERT INTO drop_tbl VALUES ('in primary')");
+
+	primary_psql("CHECKPOINT");
+
+	RewindTest::create_standby($test_mode);
+
+	# Insert additional data on primary that will be replicated to standby
+	primary_psql("INSERT INTO tbl1 values ('in primary, before promotion')");
+	primary_psql(
+		"INSERT INTO trunc_tbl values ('in primary, before promotion')");
+	primary_psql(
+		"INSERT INTO tail_tbl SELECT g, 'in primary, before promotion: ' || g FROM generate_series(1, 10000) g"
+	);
+
+	primary_psql('CHECKPOINT');
+
+	RewindTest::promote_standby();
+
+	# Insert a row in the old primary. This causes the primary and standby
+	# to have "diverged", it's no longer possible to just apply the
+	# standy's logs over primary directory - you need to rewind.
+	primary_psql("INSERT INTO tbl1 VALUES ('in primary, after promotion')");
+
+	# Also insert a new row in the standby, which won't be present in the
+	# old primary.
+	standby_psql("INSERT INTO tbl1 VALUES ('in standby, after promotion')");
+
+	# Insert enough rows to trunc_tbl to extend the file. pg_rewind should
+	# truncate it back to the old size.
+	primary_psql(
+		"INSERT INTO trunc_tbl SELECT 'in primary, after promotion: ' || g FROM generate_series(1, 10000) g"
+	);
+
+	# Truncate tail_tbl. pg_rewind should copy back the truncated part
+	# (We cannot use an actual TRUNCATE command here, as that creates a
+	# whole new relfilenode)
+	primary_psql("DELETE FROM tail_tbl WHERE id > 10");
+	primary_psql("VACUUM tail_tbl");
+
+	# Drop drop_tbl. pg_rewind should copy it back.
+	primary_psql("DROP TABLE drop_tbl");
+
+	# Create new_tbl in standby. pg_rewind should copy it from source.
+	standby_psql("CREATE TABLE new_tbl (d text) WITH(compresstype=pglz, compress_chunk_size=1024, compress_prealloc_chunks=2)");
+	standby_psql("INSERT INTO new_tbl VALUES ('in standby')");
+
+	# Before running pg_rewind, do a couple of extra tests with several
+	# option combinations.  As the code paths taken by those tests
+	# do not change for the "local" and "remote" modes, just run them
+	# in "local" mode for simplicity's sake.
+	if ($test_mode eq 'local')
+	{
+		my $primary_pgdata  = $node_primary->data_dir;
+		my $standby_pgdata = $node_standby->data_dir;
+
+		# First check that pg_rewind fails if the target cluster is
+		# not stopped as it fails to start up for the forced recovery
+		# step.
+		command_fails(
+			[
+				'pg_rewind',       '--debug',
+				'--source-pgdata', $standby_pgdata,
+				'--target-pgdata', $primary_pgdata,
+				'--no-sync'
+			],
+			'pg_rewind with running target');
+
+		# Again with --no-ensure-shutdown, which should equally fail.
+		# This time pg_rewind complains without attempting to perform
+		# recovery once.
+		command_fails(
+			[
+				'pg_rewind',       '--debug',
+				'--source-pgdata', $standby_pgdata,
+				'--target-pgdata', $primary_pgdata,
+				'--no-sync',       '--no-ensure-shutdown'
+			],
+			'pg_rewind --no-ensure-shutdown with running target');
+
+		# Stop the target, and attempt to run with a local source
+		# still running.  This fails as pg_rewind requires to have
+		# a source cleanly stopped.
+		$node_primary->stop;
+		command_fails(
+			[
+				'pg_rewind',       '--debug',
+				'--source-pgdata', $standby_pgdata,
+				'--target-pgdata', $primary_pgdata,
+				'--no-sync',       '--no-ensure-shutdown'
+			],
+			'pg_rewind with unexpected running source');
+
+		# Stop the target cluster cleanly, and run again pg_rewind
+		# with --dry-run mode.  If anything gets generated in the data
+		# folder, the follow-up run of pg_rewind will most likely fail,
+		# so keep this test as the last one of this subset.
+		$node_standby->stop;
+		command_ok(
+			[
+				'pg_rewind',       '--debug',
+				'--source-pgdata', $standby_pgdata,
+				'--target-pgdata', $primary_pgdata,
+				'--no-sync',       '--dry-run'
+			],
+			'pg_rewind --dry-run');
+
+		# Both clusters need to be alive moving forward.
+		$node_standby->start;
+		$node_primary->start;
+	}
+
+	RewindTest::run_pg_rewind($test_mode);
+
+	check_query(
+		'SELECT * FROM tbl1',
+		qq(in primary
+in primary, before promotion
+in standby, after promotion
+),
+		'table content');
+
+	check_query(
+		'SELECT * FROM trunc_tbl',
+		qq(in primary
+in primary, before promotion
+),
+		'truncation');
+
+	check_query(
+		'SELECT count(*) FROM tail_tbl',
+		qq(10001
+),
+		'tail-copy');
+
+	check_query(
+		'SELECT * FROM drop_tbl',
+		qq(in primary
+),
+		'drop');
+
+	check_query(
+		'SELECT * FROM new_tbl',
+		qq(in standby
+),
+		'new');
+
+	# Permissions on PGDATA should be default
+  SKIP:
+	{
+		skip "unix-style permissions not supported on Windows", 1
+		  if ($windows_os);
+
+		ok(check_mode_recursive($node_primary->data_dir(), 0700, 0600),
+			'check PGDATA permissions');
+	}
+
+	RewindTest::clean_rewind_test();
+	return;
+}
+
+# Run the test in both modes
+run_test('local');
+run_test('remote');
+run_test('archive');
+
+exit(0);
diff --git a/src/bin/psql/tab-complete.c b/src/bin/psql/tab-complete.c
index 24c7b414cf..41af84b234 100644
--- a/src/bin/psql/tab-complete.c
+++ b/src/bin/psql/tab-complete.c
@@ -1088,6 +1088,10 @@ static const char *const table_storage_parameters[] = {
 	"autovacuum_vacuum_insert_threshold",
 	"autovacuum_vacuum_scale_factor",
 	"autovacuum_vacuum_threshold",
+	"compress_chunk_size",
+	"compresslevel",
+	"compress_prealloc_chunks",
+	"compresstype",
 	"fillfactor",
 	"log_autovacuum_min_duration",
 	"parallel_workers",
@@ -1749,6 +1753,7 @@ psql_completion(const char *text, int start, int end)
 	/* ALTER INDEX <foo> SET|RESET ( */
 	else if (Matches("ALTER", "INDEX", MatchAny, "RESET", "("))
 		COMPLETE_WITH("fillfactor",
+					  "compresstype","compresslevel","compress_chunk_size","compress_prealloc_chunks",
 					  "vacuum_cleanup_index_scale_factor", "deduplicate_items", /* BTREE */
 					  "fastupdate", "gin_pending_list_limit",	/* GIN */
 					  "buffering",	/* GiST */
@@ -1756,6 +1761,7 @@ psql_completion(const char *text, int start, int end)
 			);
 	else if (Matches("ALTER", "INDEX", MatchAny, "SET", "("))
 		COMPLETE_WITH("fillfactor =",
+					  "compresstype =", "compresslevel =", "compress_chunk_size =", "compress_prealloc_chunks =",
 					  "vacuum_cleanup_index_scale_factor =", "deduplicate_items =", /* BTREE */
 					  "fastupdate =", "gin_pending_list_limit =",	/* GIN */
 					  "buffering =",	/* GiST */
@@ -2154,7 +2160,9 @@ psql_completion(const char *text, int start, int end)
 	/* ALTER TABLESPACE <foo> SET|RESET ( */
 	else if (Matches("ALTER", "TABLESPACE", MatchAny, "SET|RESET", "("))
 		COMPLETE_WITH("seq_page_cost", "random_page_cost",
-					  "effective_io_concurrency", "maintenance_io_concurrency");
+					  "effective_io_concurrency", "maintenance_io_concurrency",
+					  "default_compresstype", "default_compresslevel",
+					  "default_compress_chunk_size", "default_compress_prealloc_chunks");
 
 	/* ALTER TEXT SEARCH */
 	else if (Matches("ALTER", "TEXT", "SEARCH"))
diff --git a/src/include/access/gin_private.h b/src/include/access/gin_private.h
index 5cb2f72e4c..4c71973a34 100644
--- a/src/include/access/gin_private.h
+++ b/src/include/access/gin_private.h
@@ -18,6 +18,7 @@
 #include "fmgr.h"
 #include "lib/rbtree.h"
 #include "storage/bufmgr.h"
+#include "utils/rel.h"
 
 /*
  * Storage type for GIN's reloptions
@@ -27,6 +28,7 @@ typedef struct GinOptions
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
 	bool		useFastUpdate;	/* use fast updates? */
 	int			pendingListCleanupSize; /* maximum size of pending list */
+	PageCompressOpts	compress; /* page compress related options */
 } GinOptions;
 
 #define GIN_DEFAULT_USE_FASTUPDATE	true
diff --git a/src/include/access/gist_private.h b/src/include/access/gist_private.h
index b68c01a5f2..1705bfed2e 100644
--- a/src/include/access/gist_private.h
+++ b/src/include/access/gist_private.h
@@ -21,6 +21,7 @@
 #include "storage/bufmgr.h"
 #include "storage/buffile.h"
 #include "utils/hsearch.h"
+#include "utils/rel.h"
 #include "access/genam.h"
 
 /*
@@ -396,6 +397,7 @@ typedef struct GiSTOptions
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
 	int			fillfactor;		/* page fill factor in percent (0..100) */
 	GistOptBufferingMode buffering_mode;	/* buffering build mode */
+	PageCompressOpts	compress; /* page compress related options */
 } GiSTOptions;
 
 /* gist.c */
diff --git a/src/include/access/hash.h b/src/include/access/hash.h
index bab4d9f1b0..cac5087797 100644
--- a/src/include/access/hash.h
+++ b/src/include/access/hash.h
@@ -26,6 +26,7 @@
 #include "storage/bufmgr.h"
 #include "storage/lockdefs.h"
 #include "utils/hsearch.h"
+#include "utils/rel.h"
 #include "utils/relcache.h"
 
 /*
@@ -268,6 +269,7 @@ typedef struct HashOptions
 {
 	int32		varlena_header_;	/* varlena header (do not touch directly!) */
 	int			fillfactor;		/* page fill factor in percent (0..100) */
+	PageCompressOpts	compress; /* page compress related options */
 } HashOptions;
 
 #define HashGetFillFactor(relation) \
